// Copyright 1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

#import <Foundation/Foundation.h>

@interface CCTransaction : NSObject
{
    NSMutableDictionary *information;
}

- init;
- initWithInformation:(NSMutableDictionary *)info;

- (NSString *)orderID;
- (NSString *)note;
- (NSString *)amount;
- (NSString *)name;
- (NSString *)state;
- (NSString *)country;
- (NSString *)cardNumber;
- (NSString *)city;
- (NSString *)address;
- (NSString *)expiration;
- (NSString *)zipcode;
- (NSString *)transactionType;
- (NSString *)transactionStatus;
- (NSString *)merchantTransactionID;

- (NSString *)messageStatus;
- (NSString *)message;

- (void)setOrderID:(NSString *)value;
- (void)setNote:(NSString *)value;
- (void)setAmount:(NSString *)value;
- (void)setName:(NSString *)value;
- (void)setState:(NSString *)value;
- (void)setCountry:(NSString *)value;
- (void)setCardNumber:(NSString *)value;
- (void)setCity:(NSString *)value;
- (void)setAddress:(NSString *)value;
- (void)setExpiration:(NSString *)value;
- (void)setZipcode:(NSString *)value;
- (void)setTransactionType:(NSString *)value;
- (void)setTransactionStatus:(NSString *)value;
- (void)setMerchantTransactionID:(NSString *)value;

- (NSDictionary *)information;

@end
